/// <reference types="node" />
import { CID } from 'ipfs-core';
import { Buffer } from 'buffer';
import { Stack } from './stack';
export declare enum ShardKind {
    Binary = "binary",
    Object = "object"
}
declare type Data = Buffer | Record<string, any>;
export declare class Shard<TData extends Data = Data> {
    stack: Stack;
    cid: CID;
    kind: ShardKind;
    data: TData;
    private events;
    private constructor();
    put(data: TData): Promise<void>;
    on(event: 'update', listener: (shard: Shard<TData>) => void): void;
    static new<TData extends Data>(stack: Stack, kind: ShardKind, data: TData): Promise<Shard<TData>>;
    static create<TData extends Data>(stack: Stack, cid: CID, kind: ShardKind): Promise<Shard<TData>>;
    static from<TData extends Data>(stack: Stack, path: string): Promise<Shard<TData>>;
    toString(): string;
}
export {};
